
def whyrun_supported?
  true
end

action :create do
    api = XmonApi.new(
        node['xmon']['ip'],
        node['xmon']['port'],
        node["xmon"]["access_user"],
        node["xmon"]["access_key"]
    )
    
    checkHost = { :host_name => new_resource.host_name }
    ret = api.request("hosts.exist", checkHost)
    unless ret then
        converge_by("=== hosts add #{@new_resource.host_name}") do
            params = {
                :host_name => new_resource.host_name,
                :alias => new_resource.host_alias,
                ':alias' => new_resource.alias,
                :address => new_resource.address,
                :package => new_resource.package,
                :check_command => new_resource.check_command,
                :macaddress => new_resource.macaddress,
                :type => new_resource.type,
                :parents => new_resource.parents,
                :check_command_param => new_resource.check_command_param,
                :initial_state => new_resource.initial_state,
                :max_check_attempts => new_resource.max_check_attempts,
                :check_interval => new_resource.check_interval,
                :retry_interval => new_resource.retry_interval,
                :active_checks_enabled => new_resource.active_checks_enabled,
                :passive_checks_enabled => new_resource.passive_checks_enabled,
                :check_period => new_resource.check_period,
                :obsess_over_host => new_resource.obsess_over_host,
                :check_freshness => new_resource.check_freshness,
                :freshness_threshold => new_resource.freshness_threshold,
                :event_handler => new_resource.event_handler,
                :event_handler_enabled => new_resource.event_handler_enabled,
                :low_flap_threshold => new_resource.low_flap_threshold,
                :high_flap_threshold => new_resource.high_flap_threshold,
                :flap_detection_enabled => new_resource.flap_detection_enabled,
                :flap_detection_options => new_resource.flap_detection_options,
                :process_perf_data => new_resource.process_perf_data,
                :retain_status_information => new_resource.retain_status_information,
                :retain_nonstatus_information => new_resource.retain_nonstatus_information,
                :contact_groups => new_resource.contact_groups,
                :notification_interval => new_resource.notification_interval,
                :first_notification_delay => new_resource.first_notification_delay,
                :notification_period => new_resource.notification_period,
                :notification_options => new_resource.notification_options,
                :notifications_enabled => new_resource.notifications_enabled,
                :stalking_options => new_resource.stalking_options,
                :icon => new_resource.icon,
                :snmp_version => new_resource.snmp_version,
                :snmp_community => new_resource.snmp_community,
                :snmp_security_level => new_resource.snmp_security_level,
                :snmp_authtype => new_resource.snmp_authtype,
                :snmp_user => new_resource.snmp_user,
                :snmp_protocol => new_resource.snmp_protocol,
                :snmp_pass => new_resource.snmp_pass,
                :wmi_user => new_resource.wmi_user,
                :wmi_pass => new_resource.wmi_pass,
                :aws_access => new_resource.aws_access,
                :aws_secret => new_resource.aws_secret,
                :aws_region => new_resource.aws_region,
                :aws_namespace => new_resource.aws_namespace,
                :approve => new_resource.approve,
            }

            begin
                api.request("hosts.add", params)
                new_resource.updated_by_last_action(true)
            rescue XmonApiException => ex
                Chef::Log.error api.getError
            end
        end
    else
        Chef::Log.error "This Host exists."
    end
end

action :update do
    api = XmonApi.new(
        node['xmon']['ip'],
        node['xmon']['port'],
        node["xmon"]["access_user"],
        node["xmon"]["access_key"]
    )

    checkHost = { :host_name => new_resource.host_name }
    ret = api.request("hosts.exist", checkHost)
    if ret then
        converge_by("=== hosts update #{@new_resource.host_name}") do
            params = {
                :host_name => new_resource.host_name,
                :alias => new_resource.host_alias,
                ':alias' => new_resource.alias,
                :address => new_resource.address,
                :package => new_resource.package,
                :check_command => new_resource.check_command,
                :macaddress => new_resource.macaddress,
                :type => new_resource.type,
                :parents => new_resource.parents,
                :check_command_param => new_resource.check_command_param,
                :initial_state => new_resource.initial_state,
                :max_check_attempts => new_resource.max_check_attempts,
                :check_interval => new_resource.check_interval,
                :retry_interval => new_resource.retry_interval,
                :active_checks_enabled => new_resource.active_checks_enabled,
                :passive_checks_enabled => new_resource.passive_checks_enabled,
                :check_period => new_resource.check_period,
                :obsess_over_host => new_resource.obsess_over_host,
                :check_freshness => new_resource.check_freshness,
                :freshness_threshold => new_resource.freshness_threshold,
                :event_handler => new_resource.event_handler,
                :event_handler_enabled => new_resource.event_handler_enabled,
                :low_flap_threshold => new_resource.low_flap_threshold,
                :high_flap_threshold => new_resource.high_flap_threshold,
                :flap_detection_enabled => new_resource.flap_detection_enabled,
                :flap_detection_options => new_resource.flap_detection_options,
                :process_perf_data => new_resource.process_perf_data,
                :retain_status_information => new_resource.retain_status_information,
                :retain_nonstatus_information => new_resource.retain_nonstatus_information,
                :contact_groups => new_resource.contact_groups,
                :notification_interval => new_resource.notification_interval,
                :first_notification_delay => new_resource.first_notification_delay,
                :notification_period => new_resource.notification_period,
                :notification_options => new_resource.notification_options,
                :notifications_enabled => new_resource.notifications_enabled,
                :stalking_options => new_resource.stalking_options,
                :icon => new_resource.icon,
                :snmp_version => new_resource.snmp_version,
                :snmp_community => new_resource.snmp_community,
                :snmp_security_level => new_resource.snmp_security_level,
                :snmp_authtype => new_resource.snmp_authtype,
                :snmp_user => new_resource.snmp_user,
                :snmp_protocol => new_resource.snmp_protocol,
                :snmp_pass => new_resource.snmp_pass,
                :wmi_user => new_resource.wmi_user,
                :wmi_pass => new_resource.wmi_pass,
                :aws_access => new_resource.aws_access,
                :aws_secret => new_resource.aws_secret,
                :aws_region => new_resource.aws_region,
                :aws_namespace => new_resource.aws_namespace,
                :approve => new_resource.approve,
            }

            begin
                api.request("hosts.update", params)
                new_resource.updated_by_last_action(true)
            rescue XmonApiException => ex
                Chef::Log.error api.getError
            end
        end
    else
        Chef::Log.error "This Host not exists."
    end
end

action :delete do
    api = XmonApi.new(
        node['xmon']['ip'],
        node['xmon']['port'],
        node["xmon"]["access_user"],
        node["xmon"]["access_key"]
    )

    checkHost = { :host_name => new_resource.host_name }
    ret = api.request("hosts.exist", checkHost)
    if ret then
        converge_by("=== hosts delete #{@new_resource.host_name}") do
            params = {
                    :host_name => new_resource.host_name,
                    :approve => new_resource.approve,
            }

            begin
                api.request("hosts.delete", params)
                new_resource.updated_by_last_action(true)
            rescue XmonApiException => ex
                Chef::Log.error api.getError
            end
        end
    else
        Chef::Log.error "This Host not exists."
    end
end
