
def whyrun_supported?
  true
end

action :create do
    api = XmonApi.new(
        node['xmon']['ip'],
        node['xmon']['port'],
        node["xmon"]["access_user"],
        node["xmon"]["access_key"]
    )
    
    checkService = { :host_name => new_resource.host_name, :service_description => new_resource.service_description }
    ret = api.request("services.exist", checkService)
    unless ret then
        converge_by("=== services add #{@new_resource.host_name}-#{@new_resource.service_description}") do
            params = {
                :host_name => new_resource.host_name,
                :service_description => new_resource.service_description,
                :approve => new_resource.approve,
                :is_volatile => new_resource.is_volatile,
                :check_command => new_resource.check_command,
                :check_command_param => new_resource.check_command_param,
                :initial_state => new_resource.initial_state,
                :max_check_attempts => new_resource.max_check_attempts,
                :check_interval => new_resource.check_interval,
                :retry_interval => new_resource.retry_interval,
                :active_checks_enabled => new_resource.active_checks_enabled,
                :passive_checks_enabled => new_resource.passive_checks_enabled,
                :check_period => new_resource.check_period,
                :obsess_over_service => new_resource.obsess_over_service,
                :check_freshness => new_resource.check_freshness,
                :freshness_threshold => new_resource.freshness_threshold,
                :event_handler => new_resource.event_handler,
                :event_handler_enabled => new_resource.event_handler_enabled,
                :low_flap_threshold => new_resource.low_flap_threshold,
                :high_flap_threshold => new_resource.high_flap_threshold,
                :flap_detection_enabled => new_resource.flap_detection_enabled,
                :flap_detection_options => new_resource.flap_detection_options,
                :process_perf_data => new_resource.process_perf_data,
                :retain_status_information => new_resource.retain_status_information,
                :retain_nonstatus_information => new_resource.retain_nonstatus_information,
                :contact_groups => new_resource.contact_groups,
                :notification_interval => new_resource.notification_interval,
                :first_notification_delay => new_resource.first_notification_delay,
                :notification_period => new_resource.notification_period,
                :notification_options => new_resource.notification_options,
                :notifications_enabled => new_resource.notifications_enabled,
                :stalking_options => new_resource.stalking_options,
            }

            begin
                api.request("services.add", params)
                new_resource.updated_by_last_action(true)
            rescue XmonApiException => ex
                Chef::Log.error api.getError
            end
        end
    else
        Chef::Log.error "This Service exists."
    end
end

action :update do
    api = XmonApi.new(
        node['xmon']['ip'],
        node['xmon']['port'],
        node["xmon"]["access_user"],
        node["xmon"]["access_key"]
    )

    checkService = { :host_name => new_resource.host_name, :service_description => new_resource.service_description }
    ret = api.request("services.exist", checkService)
    if ret then
        converge_by("=== services update #{@new_resource.host_name}-#{@new_resource.service_description}") do
            params = {
                :host_name => new_resource.host_name,
                :service_description => new_resource.service_description,
                :approve => new_resource.approve,
                :is_volatile => new_resource.is_volatile,
                :check_command => new_resource.check_command,
                :check_command_param => new_resource.check_command_param,
                :initial_state => new_resource.initial_state,
                :max_check_attempts => new_resource.max_check_attempts,
                :check_interval => new_resource.check_interval,
                :retry_interval => new_resource.retry_interval,
                :active_checks_enabled => new_resource.active_checks_enabled,
                :passive_checks_enabled => new_resource.passive_checks_enabled,
                :check_period => new_resource.check_period,
                :obsess_over_service => new_resource.obsess_over_service,
                :check_freshness => new_resource.check_freshness,
                :freshness_threshold => new_resource.freshness_threshold,
                :event_handler => new_resource.event_handler,
                :event_handler_enabled => new_resource.event_handler_enabled,
                :low_flap_threshold => new_resource.low_flap_threshold,
                :high_flap_threshold => new_resource.high_flap_threshold,
                :flap_detection_enabled => new_resource.flap_detection_enabled,
                :flap_detection_options => new_resource.flap_detection_options,
                :process_perf_data => new_resource.process_perf_data,
                :retain_status_information => new_resource.retain_status_information,
                :retain_nonstatus_information => new_resource.retain_nonstatus_information,
                :contact_groups => new_resource.contact_groups,
                :notification_interval => new_resource.notification_interval,
                :first_notification_delay => new_resource.first_notification_delay,
                :notification_period => new_resource.notification_period,
                :notification_options => new_resource.notification_options,
                :notifications_enabled => new_resource.notifications_enabled,
                :stalking_options => new_resource.stalking_options,
            }

            begin
                api.request("services.update", params)
                new_resource.updated_by_last_action(true)
            rescue XmonApiException => ex
                Chef::Log.error api.getError
            end
        end
    else
        Chef::Log.error "This Service not exists."
    end
end

action :delete do
    api = XmonApi.new(
        node['xmon']['ip'],
        node['xmon']['port'],
        node["xmon"]["access_user"],
        node["xmon"]["access_key"]
    )

    checkService = { :host_name => new_resource.host_name, :service_description => new_resource.service_description }
    ret = api.request("services.exist", checkService)
    if ret then
        converge_by("=== services delete #{@new_resource.host_name}-#{@new_resource.service_description}") do
            params = {
                :host_name => new_resource.host_name,
                :service_description => new_resource.service_description,
                :approve => new_resource.approve,
            }

            begin
                api.request("services.delete", params)
                new_resource.updated_by_last_action(true)
            rescue XmonApiException => ex
                Chef::Log.error api.getError
            end
        end
    else
        Chef::Log.error "This Service not exists."
    end
end
